﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace SilverArcade.SilverSprite.Graphics
{
    public class ClippedSpriteImage : Sprite
    {
        TranslateTransform translate;
        System.Windows.Shapes.Rectangle rectangle;
        Texture2D texture;
        Color color;
        ImageBrush brush;
        Rectangle sourceRectangle;

        public Texture2D Texture2D
        {
            get
            {
                return texture;
            }
            set
            {
                texture = value;
                brush.ImageSource = value.Image;
            }
        }

        public Color Color
        {
            get
            {
                return color;
            }
            set
            {
                if (color != value)
                {
                    color = value;
                    Element.Opacity = color.A / 255f;
                }
            }
        }

        public ClippedSpriteImage() : base()
        {
//            canvas = new Canvas();
//            Image = new SpriteImage();
//            canvas.Children.Add(Image.Element);
            rectangle = new System.Windows.Shapes.Rectangle();
            brush = new ImageBrush();
            brush.Stretch = Stretch.None;
            translate = new TranslateTransform();
            brush.AlignmentX = AlignmentX.Left;
            brush.AlignmentY = AlignmentY.Top;
            brush.Transform = translate;
            rectangle.Fill = brush;
            Element = rectangle;
//            clip = new RectangleGeometry();
//            canvas.Clip = clip;
//            Element = canvas;
//            child = Image.Element as Image;
//            TransformGroup g = new TransformGroup();
//            child.RenderTransform = g;
//            translate = new TranslateTransform();
//            g.Children.Add(translate);
        }

        public Rectangle SourceRectangle
        {
            get
            {
                return sourceRectangle;
            }
            set
            {
                if (sourceRectangle.X != value.X ||
                    sourceRectangle.Y != value.Y)
                {
                    translate.X = -value.X;
                    translate.Y = -value.Y;
                }
                if (sourceRectangle.Width != value.Width ||
                    sourceRectangle.Height != value.Height)
                {
                    rectangle.Width = value.Width;
                    rectangle.Height = value.Height;
                }
                sourceRectangle = value;
            }
        }
    }
}
